# SWIFT V1.7 Features

The development of SWIFT V1.7 is between Feb/1/2024 and Feb/29/2024 ideally.

## Data processing

- Support dataset processing to improve dataset performance. @[tastelikefeet](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3Atastelikefeet)
- Support more dataset, including pretraining dataset @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)

## Model Evaluation

- Support model evaluation @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)
- Do evaluation of important tuners and techniques @[tastelikefeet](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3Atastelikefeet)

## Exporting

- Support model exporting to GPTQ&AWQ(Maybe CPP) @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)

## Deployment

- Support the deployment of vanilla PyTorch code @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)
- Support VLLM+AWQ/Vanilla AWQ @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)

## WEB-UI

- Support DPO @[slin000111](https://github.com/slin000111)
- Support deployment(instead of inference) @[slin000111](https://github.com/slin000111)
- Support VL/Audio models @[slin000111](https://github.com/slin000111)
- Support task management @[slin000111](https://github.com/slin000111)
- Support an alternative port of tensorboard @[slin000111](https://github.com/slin000111)

## Training

- Support FSDP @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)
- RRHF dataset improvement @[tastelikefeet](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3Atastelikefeet)

## SD

- LCM Training @[slin000111](https://github.com/slin000111)

## Multi Modal

- Support more models and datasets @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)
- Documentation @[Jintao-Huang](https://github.com/modelscope/swift/issues?q=is%3Apr+author%3AJintao-Huang)

## To be Assigned

- *Support ShengTeng GPU when training and inference*
- *Support windows for web-ui*
- *Support More LLM Models*:
  - codefuse-ai/CodeFuse-DeepSeek-33B
  - codefuse-ai/CodeFuse-13B
  - 01ai/Yi-34B-Chat-4bits
  - 01ai/Yi-34B-Chat-8bits
  - 01ai/Yi-6B-Chat-4bits
  - 01ai/Yi-6B-Chat-8bits
